{ 
               POWQUICK.PAS                                    
                     ,                                  
               BP 7.0                                          
  
                      
                            .                         
  
                    "   "                    
   }

{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V+,X+}
{$M 16384,0,655360}
PROGRAM Quick_Power;

FUNCTION Power_Rec(X : Real;N : Word) : Real;{    }
  Begin
    If N = 0 then Power_Rec := 1
    else Power_Rec := X*Power_Rec(X,N-1)
  End;

FUNCTION Power_Iter(X : Real;N : Word):Real; {    }
Var I      : Word;
    Result : Real;
  Begin
    Result := 1;
    For I := 1 to N do
      Result := Result*X;
    Power_Iter := Result
  End;

FUNCTION QPower_Rec(X : Real; N : Word) : Real; {    }
  Begin
    If N = 0 then QPower_Rec := 1
    else If odd(N) then QPower_Rec := X*QPower_Rec(X,N-1)
         else QPower_Rec := QPower_Rec(X*X,N div 2)
  End;

FUNCTION QPower_Iter(X : Real; N : Word) : Real; {    }
Var A, Result : Real;
  Begin
    Result := 1; A := X;
    While N > 0 do
      If Odd(N) then begin Result := Result*A; Dec(N) end
                else begin A := A*A; N := N div 2 end;
    QPower_Iter := Result
  End;

FUNCTION QPowerOf2(N : LongInt) : Real;
{  2  N- . /N=1,2,...,30/ }
  Begin
    QPowerOf2 := 1 shl N
  End;

FUNCTION Universal_Power(X,N : Real) : Real; {   }
  Begin
    Universal_Power := Exp(N*Ln(X))
  End;

BEGIN
  WriteLn('Power_Rec       : 7     ', Power_Rec(7,3):0:0);
  WriteLn('Power_Iter      : 6     ', Power_Iter(6,4):0:0);
  WriteLn('QPower_Rec      : 3     ', QPower_Rec(3,10):0:0);
  WriteLn('QPower_Iter     : 5     ',QPower_Iter(5,16):0:0);
  WriteLn('QPowerOf2       : 2   30  ',QPowerOf2(30):0:0);
  WriteLn('Universal_Power : 3.3   3.3  ',Universal_Power(3.3,3.3):0:10)
END.