{ 
               BINMERGE.PAS                                    
                     ,                                  
               BP 7.0                                          
  
                .        
  
                    "   "                    
   }

{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V+,X+}
{$M 16384,0,655360}
PROGRAM Binary_Merge;
CONST MAX      = 1000;
TYPE  OGR      = 0..MAX;
      DataType = Integer;
      TPosl    = Array[OGR] of DataType;
VAR   A,B,C    : TPosl;
      M,N      : OGR;

PROCEDURE INIT; {    }
Var F : TEXT;
  Begin
    Assign(F,'BINMERGE.TXT'); Reset(F); M := 0; N := 0;
    While not EoLn(F) do begin Inc(N); Read(F,A[N]) end;
    ReadLn(F);
    While not EoLn(F) do begin Inc(M); Read(F,B[M]) end;
    Close(F)
  End;

FUNCTION BinarySearch(Var M : TPosl; Left,Right : OGR; A : DataType) : OGR;
Var Middle : OGR;
  Begin
     Repeat Middle := (Left + Right) div 2;
       If M[Middle] < A then Left := Middle + 1
       else Right := Middle - 1
     Until Left > Right;
     BinarySearch := Right
  End;

PROCEDURE PRINT(Var C : TPosl; Ind : OGR); {     }
Var I : OGR; Begin For I := 1 to Ind do Write(C[I]:8); WriteLn End;

PROCEDURE BinaryMerge(Var A,B,C : TPosl; N,M : OGR); {   }
Var T,T2,CInd,K : OGR;
  Begin
    CInd := M + N;
    While (N > 0) and (M > 0) do
      If M <= N then
        begin
          T := Trunc(Ln(N/M)/Ln(2)); T2 := 1 shl T; { T2 <-- 2^T }
          If B[M] < A[N+1-T2] then
            {  A[N+1-T2],...,A[N]    }
            begin
              Dec(CInd,T2); Dec(N,T2);
              Move(A[N+1],C[CInd+1],T2*SizeOf(DataType))
            end
          else
            begin
              K := BinarySearch(A,N+2-T2,N,B[M]);
              Move(A[K+1],C[CInd-N+K+1],(N-K)*SizeOf(DataType));
              Dec(CInd,N-K+1); N := K;
              C[CInd+1] := B[M]; Dec(M)
            end
        end
      else
        begin
          T := Trunc(Ln(M/N)/Ln(2)); T2 := 1 shl T; { T2 <-- 2^T }
          If A[N] < B[M+1-T2] then
            {  B[M+1-T2],...,B[M]    }
            begin
              Dec(CInd,T2); Dec(M,T2);
              Move(B[M+1],C[CInd+1],T2*SizeOf(DataType))
            end
          else
            begin
              K := BinarySearch(B,M+2-T2,M,A[N]);
              Move(B[K+1],C[CInd-M+K+1],(M-K)*SizeOf(DataType));
              Dec(CInd,M-K+1); M := K;
              C[CInd+1] := A[N]; Dec(N)
            end
        end;
    If N = 0 then Move(B[1],C[1],M*SizeOf(DataType))
    else Move(A[1],C[1],N*SizeOf(DataType))
  End;

BEGIN
  INIT;
  BinaryMerge(A,B,C,N,M);
  WriteLn('  :'); PRINT(C,M+N)
END.