{ 
               HEAPSORT.PAS                                    
                     ,                                  
               BP 7.0                                          
  
               .       
  
                    "   "                    
   }

PROGRAM _HeapSort;
CONST N       = 100;
TYPE  TElem   = Record
         Key  : Integer;
         { ............. }
         {   }
         Data : Real
      End;
      OGR = 0..N;
VAR   M   : Array[OGR] of TElem;

PROCEDURE INIT; {       }
Var I : OGR;
  Begin
    Randomize;
    For I := 1 to N do
      M[I].Key := Random(N)+1
  End;

PROCEDURE HeapSort; {   }
Var L,R : OGR;
    X   : TElem;

  Procedure Sift; {        }
  Var I,J : OGR;
    Begin
      I := L; J := 2*I; X := M[I];
      While J <= R do
        begin
          If J < R then
            If M[J].Key < M[J+1].Key then Inc(J);
          If X.Key >= M[J].Key then Break;
          M[I] := M[J]; I := J; J := J shl 1
        end;
      M[I] := X
    End;

  Begin
    L := (N div 2) + 1; R := N;
    {    }
    While L > 1 do begin Dec(L); Sift end;
    {  }
    While R > 1 do begin X := M[1]; M[1] := M[R]; M[R] := X; Dec(R); Sift end
  End;

PROCEDURE PRINT; {       }
Var I : OGR;
  Begin
    For I := 1 to N do
      Write(M[I].Key:8)
  End;

BEGIN
   INIT;
   WriteLn('  :'); PRINT;
   HeapSort;
   WriteLn('  :'); PRINT
END.