{ 
               QUEUEU.PAS                                      
                     ,                                  
               BP 7.0                                          
  
               .                       
  
                    "   "                    
   }

{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V+,X+}
{$M 16384,0,655360}
UNIT QUEUEu;

INTERFACE

TYPE DataType = Integer;
     PQueue = ^TQueue;
     TQueue = Record
        Data : DataType;
        Next : PQueue
     End;

PROCEDURE CreateEmptyQueue(Var Top, Bottom : PQueue);{    }
FUNCTION  IsEmptyQ(Top : PQueue) : Boolean;     {     }
PROCEDURE PushQ(Var Top, Bottom : PQueue; Data : DataType);
                                            {      }
FUNCTION  PopQ(Var Top, Bottom : PQueue) : DataType;
                                                {     }
FUNCTION  GetQ(Top : PQueue):DataType; {     }
PROCEDURE BuildQueue(Var Top, Bottom : PQueue);             {   }
PROCEDURE DisposeQueue(Var Top, Bottom : PQueue);
                                        {      }


IMPLEMENTATION

PROCEDURE CreateEmptyQueue(Var Top, Bottom : PQueue);{    }
  Begin
     Top := nil;
     Bottom := nil
  End;

FUNCTION IsEmptyQ(Top : PQueue) : Boolean; {     }
  Begin
     IsEmptyQ := (Top = nil)
  End;

PROCEDURE PushQ(Var Top, Bottom : PQueue; Data : DataType);
  {      }
Var P : PQueue;
  Begin
     New(P);
     P^.data := Data;
     P^.next := nil;
     If Top = nil then
        Top := P
     else
        Bottom^.next := P;
     Bottom := P
  End;

FUNCTION PopQ(Var Top, Bottom : PQueue) : DataType;
  {     }
Var P : PQueue;
  Begin
     If Top <> nil then
       begin
          P := Top;
          PopQ := Top^.data;
          Top := Top^.next;
          Dispose(P);
          If Top = nil then
             Bottom := nil
       end
  End;

FUNCTION GetQ(Top : PQueue) : DataType;{     }
  Begin
     If Top <> nil then
       GetQ := Top^.data
  End;

PROCEDURE BuildQueue(Var Top, Bottom : PQueue); {   }
Var Data : DataType;
  Begin
    CreateEmptyQueue(Top,Bottom);
    While not Eof do
      begin
        ReadLn(Data);
        PushQ(Top,Bottom,Data)
      end
  End;

PROCEDURE DisposeQueue(Var Top, Bottom : PQueue);
  {      }
  Begin
     While not IsEmptyQ(Top) do
       PopQ(Top,Bottom)
  End;

END.