{ 
               STACKU.PAS                                      
                     ,                                  
               BP 7.0                                          
  
               .                    
  
                    "   "                    
   }

{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V+,X+}
{$M 16384,0,655360}
UNIT STACKu;

INTERFACE

TYPE DataType = Word;
     PStack = ^TStack;
     TStack = Record
        Data : DataType;
        Next : PStack
     End;

PROCEDURE CreateEmptyStack(Var Stack : PStack);        {    }
FUNCTION  IsEmpty(Var Stack : PStack) : Boolean;  {     }
PROCEDURE Push(Var Stack : PStack; Data : DataType);   {    }
FUNCTION  Pop(Var Stack : PStack) : DataType;    {     }
FUNCTION  Get(Stack : PStack):DataType; {     }
PROCEDURE BuildInvertedStack(Var Stack : PStack);             {   }
PROCEDURE DisposeStack(Var Stack : PStack); {    }

IMPLEMENTATION

PROCEDURE CreateEmptyStack(Var Stack : PStack); {    }
  Begin
     Stack := nil
  End;

FUNCTION IsEmpty(Var Stack : PStack) : Boolean; {     }
  Begin
     IsEmpty := (Stack = nil)
  End;

PROCEDURE Push(Var Stack : PStack; Data : DataType); {    }
Var P : PStack;
  Begin
     New(P);
     P^.data := Data;
     P^.next := Stack;
     Stack := P
  End;

FUNCTION Pop(Var Stack : PStack) : DataType; {     }
Var P : PStack;
  Begin
     If Stack <> nil then
       begin
          P := Stack;
          Pop := Stack^.data;
          Stack := Stack^.next;
          Dispose(P)
       end
  End;

FUNCTION Get(Stack : PStack) : DataType;{     }
  Begin
     If Stack <> nil then
       Get := Stack^.data
  End;

PROCEDURE BuildInvertedStack(Var Stack : PStack); {   }
Var Data : DataType;
  Begin
    CreateEmptyStack(Stack);
    While not Eof do
      begin
        ReadLn(Data);
        Push(Stack,Data)
      end
  End;

PROCEDURE DisposeStack(Var Stack : PStack); {    }
  Begin
     While not IsEmpty(Stack) do
       Pop(Stack)
  End;


END.