{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V+,X+}
{$M 16384,0,655360}
{ 
               CYCLES.PAS                                      
                     ,                                  
               BP 7.0                                          
  
                .  
  
                    "   "                    
   }

PROGRAM FundamentalCycles;
USES GraphU;
CONST Max        = 100;
TYPE  OGR        = 0..MAX;
VAR   Head, Tail : PVzel;
      Count      : LongInt;
      Ind        : OGR;
      Stack      : Array[OGR] of PVzel;

PROCEDURE PrintCycle(V,U : PVzel); {      }
Var I : OGR;
  Begin
    If Ind > 0 then
      begin
        I := Ind; Write('{',U^.Data,',');
        While (I <> 0) and (Stack[I] <> U) do
          begin Write(Stack[I]^.Data,','); Dec(I) end;
        WriteLn(U^.Data,'}')
      end
  End;

PROCEDURE FindCycles(P,Parent : PVzel);
  {          }
Var T : PRebro;
  Begin
    Inc(Count); P^.Num := Count;
    {    P }
    T := P^.Nasl;
    While T <> nil do
      begin
        If T^.Vz^.Num = 0 then
          begin Inc(Ind); Stack[Ind]:=T^.Vz; FindCycles(T^.Vz,P); Dec(Ind) end
        else If (T^.Vz^.Num < P^.Num) and (T^.Vz <> Parent) then
          PrintCycle(P,T^.Vz);
        T := T^.Next
      end
  End;

PROCEDURE Obhod; {       }
Var P : PVzel;
  Begin
    P := Head; Count := 0; Ind := 0;
    While P <> Tail do
      begin
        If P^.Num = 0 then FindCycles(P,nil);
        P := P^.next
      end
  End;

BEGIN
   BuildGraph(Head,Tail,Oriented);
   Write('   : '); Pass(Head,Tail); WriteLn;
   Naslednici(Head,Tail); WriteLn;
   WriteLn('    : '); Obhod
END.