{ 
               COMB.PAS                                        
                     ,                                  
               BP 7.0                                          
  
               .    
                             .               
  
                    "   "                    
   }

PROGRAM COMBINATIONS;
CONST MAX    = 100;
TYPE  OGR    = 0..MAX;
      TArray = Array[OGR] of OGR;
VAR   M      : TArray;
      N, K   : OGR;

PROCEDURE PRINT; {     }
Var I : OGR;
  Begin
    For I := 1 to K do
      Write(M[I]:4);
    WriteLn
  End;

PROCEDURE Comb_Rec(NN : OGR); {     }
Var I : OGR;
  Begin
    If NN = (K+1) then PRINT
    else
      For I := M[NN-1]+1 to N-K+NN do
        begin M[NN] := I; Comb_Rec(NN+1) end
  End;

PROCEDURE Comb_Iter(N,K : OGR); {     }
Var I, J : OGR;
  Begin
    If K = 0 then Exit; {      }
    {   }
    M[0] := 0;
    For I := 1 to K do M[I] := I;
    PRINT; {    }
    While (M[1] < N-K+1) or (M[K] < N) do
      begin
        I := K; {  ,    }
        While M[I] = N-K+I do Dec(I);
        Inc(M[I]); {   }
        {         }
        For J := I+1 to K do M[J] := M[J-1]+1;
        PRINT {    }
      end
  End;

FUNCTION CodeComb(N,K : OGR; Var Comb : TArray) : LongInt; { }
Var Cod,d,I,J,m,q,s : LongInt;
Begin
  Cod := 0;
  If k = 0 then d := 0 else d := Comb[1]-1;
  For I := 1 to k-1 do
    begin
      Dec(n); q := k-I;
      For J := 1 to d do
        begin
          s := 1; For m := 1 to n-q do s := s*(q+m) div m;
          Inc(Cod,s); Dec(n)
        end;
      d := Comb[I+1]-Comb[I]-1
    end;
  CodeComb := Cod+d
End;

PROCEDURE DecodeComb(Code : LongInt; N,K : OGR; Var Comb : TArray); {}
Var I,d,m,r,s : LongInt;
Begin
  d := 0;
  For I := 1 to k do
    begin
      Dec(n); Dec(k); r := 0; Comb[I] := 0;
      Repeat
        s:=1;
        For m := 1 to n-k do s := s*(k+m) div m;
        If Code >= r+s then begin Dec(n); Inc(r,s); Inc(Comb[I]); s := 0 end;
      Until Code < r+s;
      Dec(Code,r); Inc(d,Comb[I]+1); Comb[I] := d
    end
End;

BEGIN
    Write('   : N = '); ReadLn(N);
    Write('  : K = '); ReadLn(K);
    WriteLn(' : '); Comb_Iter(N,K);
    WriteLn(' : '); M[0] := 0; Comb_Rec(1);

    N := 5; K := 3; M[1] := 2; M[2] := 3; M[3] := 5;
    WriteLn('N=5, K=3,   C=(2,3,5) : ',CodeComb(N,K,M));

    DecodeComb(3,N,K,M);
    Write('N=5, K=3, ,    3 :'); PRINT
END.