{ 
               PERMUTE.PAS                                     
                     ,                                  
               BP 7.0                                          
  
               ,    
                             ,  , 
                           ,   -   
                            ,  .   
  
                    "   "                    
   }

PROGRAM PERMUTE;
CONST MAX    = 1000;
TYPE  OGR    = 0..MAX;
      TArray = Array[OGR] of OGR;
VAR   I,N    : OGR;
      A,B,C  : TArray;

PROCEDURE PRINT(N : OGR; Var A : TArray); {     }
Var I : OGR;
  Begin
     For I := 1 to N do
       Write(A[I]:4);
     WriteLn
  End;

PROCEDURE Perm(K : OGR); {    N  }
Var I,Pom : OGR;
  Begin
    If K = 1 then PRINT(N,A)
    else
      begin
        Perm(K-1);
        For I := 1 to K-1 do
          begin
            Pom := A[I]; A[I] := A[K]; A[K] := Pom;
            Perm(K-1);
            Pom := A[I]; A[I] := A[K]; A[K] := Pom
          end
      end
  End;

FUNCTION ChetnostPerm(N : OGR; Var P : TArray) : Boolean;
 {    : True - , False -  }
Var Sgn  : Boolean;
    I,J  : OGR;
Begin
  Sgn := True;
  For I := 1 to N-1 do
    For J := I+1 to N do
      If P[I] > P[J] then Sgn := not Sgn;
  ChetnostPerm := Sgn
End;

FUNCTION ChetnostPerm2(N : OGR; Var P : TArray) : Boolean;
 {    : True - , False -  }
Var Sgn  : Boolean;
    I,J  : OGR;
    Used : Array[OGR] of Boolean;
Begin
  Sgn := True; FillChar(Used, SizeOf(Used),False);
  For I := 1 to N do
    If not Used[I] then
      begin
        J := P[I];
        While J <> I do
          begin Used[J] := True; Sgn := not Sgn; J := P[J] end
      end;
  ChetnostPerm2 := Sgn
End;

PROCEDURE ProizvCikli(N : OGR; Var P : TArray);
 {        
     }
Var I,J  : OGR;
    Used : Array[OGR] of Boolean;
Begin
  FillChar(Used,SizeOf(Used),False);
  For I := 1 to N do
    If not Used[I] then
      begin
        Write('(',I); J := P[I];
        While J <> I do begin Write(',',J); Used[J] := True; J := P[J] end;
        Write(')')
      end;
  WriteLn
End;

PROCEDURE ProizvCikli2(N : OGR; Var P : TArray);
 {        
    .     1. }
Var I,J  : OGR;
    Used : Array[OGR] of Boolean;
    Iden : Boolean;
Begin
  FillChar(Used,SizeOf(Used),False); Iden := True;
  For I := 1 to N do
    If not Used[I] then
      begin
        J := P[I];
        If J <> I then
          begin
            Write('(',I); Iden := False;
            While J <> I do begin Write(',',J); Used[J] := True; J := P[J] end;
            Write(')')
          end
      end;
  If Iden then Write('id');
  WriteLn
End;

FUNCTION NOD(a,b : LongInt) : LongInt;{ -    a  b}
Var Tmp : LongInt;
  Begin
    While b > 0 do begin Tmp := b; b := a mod b; a := Tmp end;
    NOD := a
  End;

FUNCTION NOK(a,b : LongInt) : LongInt;{ -    a  b}
  Begin NOK := (a div NOD(a,b))*b End;

FUNCTION PermStepen(N : OGR; Var P : TArray) : LongInt;
 {     }
Var I,J, CurLen  : OGR;
    Used         : Array[OGR] of Boolean;
    Rezult       : LongInt;
Begin
  FillChar(Used,SizeOf(Used),False); Rezult := 1;
  For I := 1 to N do
    If not Used[I] then
      begin
        J := P[I]; CurLen := 1;
        While J <> I do begin Used[J] := True; J := P[J]; Inc(CurLen) end;
        Rezult := NOK(Rezult,CurLen)
      end;
  PermStepen := Rezult
End;

PROCEDURE MultiplyPerm(N : OGR; Var P1,P2,Proizv : TArray);
  {   P1  P2 }
  { P1  P2    VAR-,      }
Var I : OGR;
  Begin
    For I := 1 to N do
      Proizv[I] := P1[P2[I]]
  End;

FUNCTION CodePerm(N : OGR; Var Perm : TArray): LongInt;
 {      Perm    0-(n-1)! }
Var P : TArray;
    I,Razl,Poz,Rezult : LongInt;
Begin
  {  }
  Rezult := 0;
  For I := 1 to N do P[I] := I;
  {  }
  For Poz := 1 to N do
    begin
      Razl := 1;
      While Perm[Poz] <> P[Razl] do
         Inc(Razl);
      Rezult := Rezult*(n-Poz+1) + Razl-1;
      For I := Razl+1 to N do P[I-1] := P[I]
    end;
  CodePerm := Rezult
End;

PROCEDURE DecodePerm(Code : LongInt; N : OGR; Var Perm : TArray);
{        0  N!-1 }
Var I,Poz,Razl : LongInt;
    P : TArray;
Begin
  For I := 1 to N do P[I] := I;
  For Poz:= N downto 1 do
    begin
      Razl := n-Poz+1; Perm[Poz] := Code mod Razl;
      Code := Code div Razl
    end;
  For Poz := 1 to N do
    begin
      Razl := Perm[Poz]+1; Perm[Poz] := P[Razl];
      For I := Razl+1 to N do P[I-1] := P[I]
    end
End;

BEGIN
   Write(' N = '); ReadLn(N);
   For I := 1 to N do A[I] := I;
   Perm(N);

   N := 3; A[1] := 2; A[2] := 3; A[3] := 1;
   Write(' N=3,  P=(2,3,1)  ');
   If ChetnostPerm(N,A) then WriteLn('!') else WriteLn('!');
   WriteLn('    ',CodePerm(N,A));
   WriteLn('   4 :'); DecodePerm(4,N,A); PRINT(N,A);

   N := 6; A[1] := 4; A[2] := 3; A[3] := 5; A[4] := 6; A[5] := 2; A[6] := 1;
   WriteLn(' 435621  : ', PermStepen(N,A));
   WriteLn('          : ');
   ProizvCikli(N,A);
   B[1] := 1; B[2] := 5; B[3] := 4; B[4] := 6; B[5] := 3; B[6] := 2;
   MultiplyPerm(N,A,B,C);
   WriteLn('  435621  154632 :'); PRINT(N,C)
END.