{ 
               BROY_SYS.PAS                                    
                     ,                                  
               BP 7.0                                          
  
               .    
  
               101                   
   }

PROGRAM Brojni_Sistemi;
CONST Eps = 0.0001;

FUNCTION GetChar(N : Byte) : Char; {  ,   N }
  Begin If N < 10 then GetChar := Chr(N+48) else GetChar := Chr(N+55) End;

FUNCTION GetValue(Ch : Char) : Byte; {     Ch }
  Begin
    If Ch in ['0'..'9'] then GetValue := Ord(Ch)-48
    else GetValue := Ord(Ch)-55
  End;

FUNCTION Convert(N : LongInt; Base : Byte) : String;
  {    N      Base }
Var Rezult : String;
  Begin
    Rezult := '';
    While N > 0 do
      begin Rezult := GetChar(N mod Base) + Rezult; N := N div Base end;
    Convert := Rezult
  End;

FUNCTION ConvertLessThan1(N : Extended; Base, Count : Byte) : String;
  {    0<=N<1      Base
        Count       }
Var Rezult : String;
    I      : Byte;
  Begin
    Rezult := '0.';
    For I := 1 to Count do
      begin
        {     0? }
        If Abs(N) < Eps then begin ConvertLessThan1 := Rezult; Exit end;
        N := N*Base; Rezult := Rezult+GetChar(Trunc(N)); N := N-Int(N)
      end;
    ConvertLessThan1 := Rezult
  End;

FUNCTION ConvertReal(N : Extended; Base, Count : Byte) : String;
  {     N      Base }
Var Tmp   : String;
    Minus : Boolean;
  Begin
    Minus := N < 0; N := Abs(N);
    Tmp := ConvertLessThan1(N-int(N),Base,Count); Delete(Tmp,1,1);
    Tmp := Convert(Trunc(N),Base) + Tmp;
    If Tmp[1] = '.' then Tmp := '0' + Tmp;
    If Minus then Tmp := '-' + Tmp;
    ConvertReal := Tmp
  End;

FUNCTION Calculate(S : String; Base : Byte) : LongInt;
  {      S,    
      Base }
Var I      : Byte;
    Rezult : LongInt;
  Begin
    Rezult := 0;
    For I := 1 to Length(S) do
      Rezult := Rezult*Base + GetValue(S[I]);
    Calculate := Rezult
  End;

FUNCTION CalculateLessThan1(S : String; Base : Byte) : Extended;
  {      0<S<1,    
      Base }
Var I      : Byte;
    Rezult : Extended;
  Begin
    Delete(S,1,2); {  "0."    S }
    Rezult := 0;
    For I := Length(S) downto 1 do
      Rezult := (Rezult + GetValue(S[I])) / Base;
    CalculateLessThan1 := Rezult
  End;


FUNCTION CalculateReal(S : String; Base : Byte) : Extended;
  {       S, 
         Base }
Var PointPos : Byte;
    Minus    : -1..1;
  Begin
     If S[1] = '-' then begin Minus := -1; Delete(S,1,1) end else Minus := 1;
     If Pos('.',S) = 0 then S := S + '.0';
     PointPos := Pos('.',S);
     CalculateReal := Minus * (Calculate(Copy(S,1,PointPos-1),Base) +
        CalculateLessThan1('0.'+Copy(S,PointPos+1,Length(S)-PointPos), Base))
  End;

VAR N    : LongInt;
    S    : String;
    Base : Byte;
BEGIN
   WriteLn('!!!       !!!');
   WriteLn('   777.777 (10)  : ',ConvertReal(777.777,7,10));
   WriteLn('   11.D873 (16)  : ',CalculateReal('11.D873',16):0:10);
END.