{ 
               COMBSORT.PAS                                    
                     ,                                  
               BP 7.0                                          
  
                        
                         "  ".                       
  
                    "   "                    
   }

{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V+,X+}
{$M 16384,0,655360}

PROGRAM COMBSORT_;
CONST N       = 100;
TYPE  TElem   = Record
         Key  : Integer;
         { ............. }
         {   }
         Data : Real
      End;
      OGR = 0..N;
VAR   M   : Array[OGR] of TElem;

PROCEDURE INIT; {       }
Var I : OGR; Begin Randomize; For I := 1 to N do M[I].Key := Random(N)+1 End;

PROCEDURE Swap(Var El1,El2 : TElem); {      }
Var Tmp : TElem; Begin Tmp := El1; El1 := El2; El2 := Tmp End;

PROCEDURE CombSort(Var M : Array of TElem; N : OGR);
   {        }
Var Switch,I,J : OGR;
    Gap : LongInt;
  Begin
    Gap := N;
    Repeat
      Switch := 0; Gap := Gap*6 shr 3; { Gap := Trunc(Gap/1.3);}
      If Gap < 1 then Gap := 1;
      For I := 1 to N - Gap do
        begin
          J := I + Gap;
          If M[I].Key > M[J].Key then begin Swap(M[I],M[J]); Inc(Switch) end
        end
    Until (Switch = 0) and (Gap = 1)
  End;

PROCEDURE PRINT; {       }
Var I : OGR; Begin For I := 1 to N do Write(M[I].Key:8) End;

BEGIN
  INIT;
  WriteLn('  : '); PRINT;
  CombSort(M,N);
  WriteLn('  : '); PRINT
END.