{ 
               QSORT.PAS                                       
                     ,                                  
               BP 7.0                                          
  
                   
                          /C.A.R. Hoare/                             
  
                    "   "                    
   }

PROGRAM QuickSort;
CONST N   = 100;
TYPE  TElem   = Record
         Key  : Integer;
         { ............. }
         {   }
         Data : Real
      End;
      OGR = 0..N;
VAR   M   : Array[OGR] of TElem;

PROCEDURE INIT; {       }
Var I : OGR;
  Begin
    Randomize;
    For I := 1 to N do
      M[I].Key := Random(N)+1
  End;

PROCEDURE Swap(Var El1,El2 : TElem); {      }
Var Tmp : TElem; Begin Tmp := El1; El1 := El2; El2 := Tmp End;

PROCEDURE QSort(L,R : Word); {   }
Var I,J,X : OGR;
  Begin
    I := L; J := R; X := M[(I+J) div 2].Key;
    Repeat
      While X > M[I].Key do Inc(I);
      While X < M[J].Key do Dec(J);
      If I <= J then begin Swap(M[I],M[J]); Inc(I); Dec(J) end
    Until I > J;
    If J > L then QSort(L,J);
    If I < R then QSort(I,R)
  End;

PROCEDURE PRINT; {     }
Var I : OGR;
  Begin
    For I := 1 to N do
      Write(M[I].Key:8)
  End;

BEGIN
  INIT;
  WriteLn('  : '); PRINT;
  QSort(1,N);
  WriteLn('  : '); PRINT
END.