{ 
               RADSORT.PAS                                     
                     ,                                  
               BP 7.0                                          
  
              . 
  
                    "   "                    
   }

PROGRAM RadixSort;
CONST N   = 100;
TYPE  TElem   = Record
         Key  : LongInt;
         { ............. }
         {   }
         Data : Real
      End;
      OGR = 0..N+1;
VAR   M   : Array[OGR] of TElem;

PROCEDURE INIT; {       }
Var I : OGR;
  Begin
    Randomize;
    For I := 1 to N do
      M[I].Key := Random(N)+1
  End;

PROCEDURE Swap(Var El1,El2 : TElem); {      }
Var Tmp : TElem; Begin Tmp := El1; El1 := El2; El2 := Tmp End;

PROCEDURE RadSort(L,R : OGR; BitMask : LongInt); {   }
Var I,J : OGR;
  Begin
    If (R > L) and (BitMask > 0) then
      begin
        I := L; J := R;
        While J <> I do
          begin
            While ((M[I].Key and BitMask) = 0) and (I < J) do Inc(I);
            While ((M[J].Key and BitMask) <> 0) and (J > I) do Dec(J);
            Swap(M[I],M[J])
          end;
        If (M[R].Key and BitMask) = 0 then Inc(J);
        RadSort(L,J-1,BitMask shr 1);
        RadSort(J,R,BitMask shr 1)
      end
  End;

PROCEDURE PRINT; {     }
Var I : OGR; Begin For I := 1 to N do Write(M[I].Key:8) End;

BEGIN
  INIT;
  WriteLn('  : '); PRINT;
  RadSort(1,N,1 shl 30);
  WriteLn('  : '); PRINT
END.