{ 
               IZVTREE.PAS                                     
                     ,                                  
               BP 7.0                                          
  
               .         
  
                    "   "                    
   }

{$A+,B-,D+,E+,F-,G+,I+,L+,N-,O-,P-,Q-,R-,S-,T-,V+,X+}
{$M 65520,0,655360}

UNIT IzvTree;

INTERFACE

CONST	MaxN  = 3000;
TYPE  PTree = ^TTree;
      TTree = Record
                 Data        : String;
                 Left, Right : PTree;
                 Position    : Word;
               End;

PROCEDURE DrawTree( Root : PTree;  N : Word ); {     }

IMPLEMENTATION

PROCEDURE DrawTree(Root : PTree; N : Word);
Type TreeRow = Array [1..(MaxN div 2+2)] of PTree;
Var  I, J, K, P, P1, P2, P3, P4, Len : Word;
     Scan1, Scan2, Scan : ^TreeRow;

   Procedure CalculatePositions(T : PTree);
   {  .      }
     begin
       If T <> nil then
         begin
           CalculatePositions(T^.Left);
          {        }
          {        }
           Len := Length(T^.Data);
           T^.Position := K + (Len+1) div 2;
           Inc(K,Len);
           CalculatePositions(T^.Right)
         end
     end;

begin
  New(Scan1); New(Scan2); K := 0;
  CalculatePositions(Root);
  Scan1^[1] := Root; Scan1^[2] := nil;
  {           }
  While Scan1^[1] <> nil do
    begin
      For K := 1 to 1 do
      {      }
        begin
          I := 1; J := 1;
          While Scan1^[I] <> nil do
          {       }
            begin
              While J < Scan1^[I]^.Position do begin Write(' '); Inc(J) end;
              Write(''); Inc(I); Inc(J)
            end;
          WriteLn
        end;

      I := 1; J := 1; P := 1;
      While Scan1^[I] <> nil do
      {          }
      begin
      {     Scan1^[I]  }
      {  Scan2^ -      }
        If Scan1^[I]^.Left <> nil then
          begin Scan2^[J] := Scan1^[I]^.Left; Inc(J) end;
        If Scan1^[I]^.Right <> nil then
          begin Scan2^[J] := Scan1^[I]^.Right; Inc(J) end;

  {          }
        K := Length(Scan1^[I]^.Data);
        P2 := Scan1^[I]^.Position - (K-1) div 2; P3 := P2 + K;
        If Scan1^[I]^.Left = nil then P1 := P2
        else P1 := Scan1^[I]^.Left^.Position;
        If Scan1^[I]^.Right = nil then P4 := P3
        else P4 := Scan1^[I]^.Right^.Position;
  {        }
        While P < P1 do begin Write(' '); Inc(P) end;
        If P1 <> P2 then begin Write(''); Inc(P) end;
        While P < P2 do begin Write(''); Inc(P) end;
        Write( Scan1^[I]^.Data); P := P3;
        While P < P4 do begin Write(''); Inc(P) end;
        If Scan1^[I]^.Right <> nil then begin Write(''); Inc(P) end;
        Inc(I)
      end;
      Scan2^[J] := nil; WriteLn; Scan := Scan1; Scan1 := Scan2; Scan2 := Scan
    end;

  Dispose(Scan1); Dispose(Scan2)
End;     { DrawTree }

End.