{ 
               DOMINATE.PAS                                    
                     ,                                  
               BP 7.0                                          
  
               -  
                          ,       
                               
                           .                        
  
                    "   "                    
   }

PROGRAM Dominate;
CONST MaxVr   = 100;
TYPE  OGR     = 0..MAXVr;
      TVzel   = Record
                  BrNasl : OGR;
                  Nasl   : Array[OGR] of OGR
                End;
      TGraph  = Array[OGR] of TVzel;{ ,     }
      TVruhSet = Array[OGR] of Boolean; {    }

VAR G : TGraph;
    N : OGR;

PROCEDURE INIT; {        .
                    - N (  )
                   N  -     I- . }
Var F : TEXT;
    I : OGR;
  Begin
    Assign(F,'DOMINATE.TXT'); Reset(F); FillChar(G,SizeOf(G),0);
    ReadLn(F,N);
    For N := 1 to N do
      begin
        While not EoLn(F) do
          With G[N] do begin Read(F,I); Inc(BrNasl); Nasl[BrNasl] := I end;
        ReadLn(F)
      end;
    Close(F)
  End;

PROCEDURE FindDominationSet(Var G : TGraph; Var D : TVruhSet);
  {   D        }
Var Vazmojni,Poseten : TVruhSet;
    P : OGR;
  Procedure Obhodi(V : OGR);  {       V   }
    Begin {       D,     Vazmozno }
      If Poseten[V] then Exit;
      Poseten[V] := True; Vazmojni[V] := False; D[V] := False;
      With G[V] do
        For V := 1 to BrNasl do
          Obhodi(Nasl[V])
    End;
Begin
  FillChar(Vazmojni,SizeOf(Vazmojni),True); FillChar(D,SizeOf(D),False);
  For P := 1 to N do
    If Vazmojni[P] then
      begin
        FillChar(Poseten,SizeOf(Poseten),False);
        Obhodi(P); D[P] := True
      end
End;

PROCEDURE MakeStronglyConnected; {      }
Type TDostijimost = Array[OGR,OGR] of Boolean;
Var  G1                         : ^TGraph;
     D,CD                       : TVruhSet;
     I,u,v,p1,q1,p2,q2,BrD,BrCD : OGR;
     ImaPath                    : ^TDostijimost;

   Procedure Obhodi(V : OGR);
   {     "  "  G }
     Begin
       If ImaPath^[I,V] then Exit;
       ImaPath^[I,V] := True;
       With G[V] do
         For V := 1 to BrNasl do
           Obhodi(Nasl[V])
     End;

   Procedure FindP1Q1P2Q2(Var pp1,qq1,pp2,qq2 : OGR);
   Var p1,q1,p2,q2: byte;  (*  {p1,q1}  {p2,q2}, p1<>p2, q1<>q2 *)
   Begin
     For p1 := 1 to N do
       If D[p1] then
         For q1 := 1 to N do
           If CD[q1] and ImaPath^[p1,q1] then
             For p2 := 1 to N do
               If D[p2] and ((p2<>p1) or (BrD=1)) then
                 For q2 := 1 to N do
                   If CD[q2] and ((q2<>q1)or(BrCD=1)) and ImaPath^[p2,q2] then
                     begin pp1 := p1; qq1 := q1; pp2 := p2; qq2 := q2; Exit end
   End;

   Procedure CreateG1; {    G1 }
   Var I,U,V : OGR;
     Begin
       New(G1); FillChar(G1^,SizeOf(G1^),0);
       For u := 1 to N do
         With G[u] do
           For I := 1 to BrNasl do
             begin
               v := Nasl[I];
               With G1^[v] do begin Inc(BrNasl); Nasl[BrNasl] := u end
             end
     End;

   Function GetBr(Var VruhSet : TVruhSet) : OGR;
     {       VruhSet }
   Var I, Count : OGR;
     Begin
       Count := 0;
       For I := 1 to N do
         If VruhSet[I] then Inc(Count);
       GetBr := Count
     End;

Begin
  FindDominationSet(G,D); {  D }
  CreateG1;               {    G1 }
  FindDominationSet(G1^,CD); { CD}
  Dispose(G1); {     }
  BrD := GetBr(D); BrCD := GetBr(CD); {    .  D  CD }

  New(ImaPath); FillChar(ImaPath^,SizeOf(ImaPath^),False);
  For I := 1 to N do {     "  "  G }
     Obhodi(I);

  While (BrD > 1) or (BrCD > 1) do
    begin
      FindP1Q1P2Q2(p1,q1,p2,q2);
      Write(q2,'',p1,'   ');
      For u := 1 to N do {   q2-p1   ImaPath }
        If ImaPath^[u,q2] then
          For v := 1 to N do
            If ImaPath^[p1,v] then
              ImaPath^[u,v] := True;

      If BrD > 1 then begin Dec(BrD); D[p1] := False end; { . p1  D }
      If BrCD > 1 then begin Dec(BrCD); CD[q2] := False end { . q2  CD }
    end;
  For p1 := 1 to N do If D[p1] then Break;
  For q2 := 1 to N do If CD[q2] then Break;
  If p1 = q2 then {  D  CD     }
    begin WriteLn('   !'); Exit end;
  WriteLn(q2,'',p1,'   ')
End;

VAR D : TVruhSet;
    I : OGR;
BEGIN
  INIT;
  Write('   : ');
  FindDominationSet(G,D);
  For I := 1 to N do
    If D[I] then Write(I,' ');
  WriteLn; WriteLn;

  WriteLn('         : ');
  MakeStronglyConnected
END.