{ 
               FLOYD.PAS                                       
                     ,                                  
               BP 7.0                                          
  
                     
                                   
                           .                               
                             .               
  
                    "   "                    
   }

PROGRAM FLOYD_;
CONST MAX  = 100;
TYPE  OGR  = 0..MAX;
VAR   A    : Array [OGR,OGR] of Word;
      Path : Array [OGR,OGR] of OGR;
      N    : OGR;

PROCEDURE INIT; {    }
Var I,J : OGR;
  Begin
    Write(',     N = '); ReadLn(N);
    WriteLn(',      .');
    WriteLn('  ,  0.');
    For I := 1 to N do
      For J := 1 to N do
        begin
          If I <> J then
            begin Write('  ',I,'  ',J,' : '); ReadLn(A[I,J]) end
          else A[I,J] := 0;
          If A[I,J] <> 0 then Path[I,J] := J else Path[I,J] := 0
        end
  End;

PROCEDURE FLOYD; {     }
Var I,J,K : OGR;
   Begin
     For K := 1 to N do
       For I := 1 to N do
         If A[I,K] <> 0 then
           For J := 1 to N do
             If (A[I,J] > (A[I,K] + A[K,J])) and (A[K,J] <> 0) then
               begin A[I,J] := A[I,K] + A[K,J]; Path[I,J] := Path[I,K] end
   End;

PROCEDURE PRINT; {    -    }
Var I,J : OGR;
  Begin
    For I := 1 to N do
      begin
	For J := 1 to N do
          If A[I,J] <> 0 then Write(A[I,J]:6) else Write('  ----');
	WriteLn
      end
  End;

PROCEDURE WritePath; {  -     }
Var Nach, Kraj : OGR;
  Begin
    Write(',    : '); ReadLn(Nach);
    Write(',    : '); ReadLn(Kraj);
    If Path[Nach,Kraj] = 0 then
      WriteLn('     !')
    else
      begin
        Write('    : ');
        While Nach <> Kraj do begin Write(Nach,' '); Nach:=Path[Nach,Kraj] end;
        WriteLn(Nach)
      end
  End;

BEGIN
  INIT;
  WriteLn('    ...'); PRINT;
  FLOYD;
  WriteLn('...  ...'); PRINT;
  WritePath
END.