{ 
               KRUSKAL.PAS                                     
                     ,                                  
               BP 7.0                                          
  
                       
                           .                          
  
                    "   "                    
   }

PROGRAM KRUSKAL_;
CONST MaxRebra = 29;
TYPE  OGR      = 0..MaxRebra;
      TTeglo   = Word;
      Rebro    = Record
                   V1,V2 : OGR;
                   Teglo : TTeglo
                 End;
     TGraph    = Array[OGR] of Rebro;
VAR  G         : TGraph;
     Prev      : Array[OGR] of OGR; {    }
     N         : OGR;

PROCEDURE INIT; {    -   N  - G[1..N] }
Var F : TEXT;
  Begin
    Assign(F,'KRUSKAL.TXT'); Reset(F); N := 0;
    While not Eof(F) do begin Inc(N); With G[N] do ReadLn(F,V1,V2,Teglo) end;
    Close(F)
  End;

Procedure QuickSort(Var A : TGraph; Lo,Hi : OGR);
{        .  O(N.logN) }
Var I,J  : OGR;
    Mid  : TTeglo;
    Swap : Rebro;
  Procedure QSort(Left,Right:word);
    Begin
      I := Left; J := Right; Mid := A[(Left+Right) div 2].Teglo;
      Repeat
        While A[I].Teglo < Mid do Inc(I);
        While Mid < A[J].Teglo do Dec(J);
        If I <= J then
          begin Swap := A[I]; A[I] := A[J]; A[J] := Swap; Inc(I); Dec(J) end
      Until I > J;
      If Left < J then QSort(Left,J);
      If I < Right then QSort(I,Right)
    End;
Begin QSort(Lo,Hi) End;

FUNCTION GetRoot(V : OGR) : OGR;
Var Koren,VV, SaveVV : OGR;
  Begin
    {     }
    Koren := V; While Prev[Koren] <> 0 do Koren := Prev[Koren];
    {     }
    VV := V; While VV <> Koren do
      begin SaveVV := VV; VV := Prev[VV]; Prev[SaveVV] := Koren end;
    GetRoot := Koren
  End;

PROCEDURE Kruskal;
Var I,V1Komp,V2Komp : OGR;
  Begin
    QuickSort(G,1,N); FillChar(Prev,SizeOf(Prev),0);
    For I := 1 to N do {          }
      With G[I] do     {       }
        begin { V1Komp  ,  V1,  V2Komp -  V2 }
          V1Komp := GetRoot(V1);
          V2Komp := GetRoot(V2);
          If V1Komp <> V2Komp then {  V1  V2     }
            begin Write('{',V1,',',V2,'} '); Prev[V2Komp] := V1Komp end
        end;
  End;

BEGIN
  INIT;
  WriteLn('    :'); Kruskal;
  WriteLn
END.