{ 
               MOD_TREE.PAS                                    
                     ,                                  
               BP 7.0                                          
  
               ()      
                               .     
  
                    "   "                    
   }

PROGRAM MOD_TREE;
CONST MAX = 100;
TYPE  OGR = 1..MAX;
      DataType = Integer;
VAR   M : Array[OGR,OGR] of DataType;
      Tree : Array[OGR] of RECORD X,Y : OGR END;
      Used : Array[OGR] of Boolean;
      N : OGR;

PROCEDURE INIT;
Var F : TEXT;
    X,Y : OGR;
    Value : DataType;
  Begin
     FillChar(Used,SizeOf(Used),False);
     Assign(F,'MOD_TREE.TXT'); Reset(F);
     ReadLn(F,N); {     }
     For X := 1 to N do
       For Y := 1 to N do
         M[X,Y] := MaxInt;
     While not Eof(F) do
       {    -->    }
       begin ReadLn(F,X,Y,Value); M[X,Y] := Value; M[Y,X] := Value end;
     Close(F)
  End;

PROCEDURE Prim; {       Dist }
Var I,J,K,X,Y : OGR;
    MinDist   : DataType;
  Begin
     {     }
     Used[1] := True;
     {      }
     For K := 1 to N-1 do
       begin
         MinDist := MaxInt;
         For I := 1 to N do
           For J := 1 to N do
             If (I<>J) and Used[I] and not Used[J] and
                (M[I,J] < MinDist) then
                begin X := I; Y := J; MinDist := M[I,J] end;
         {   Y      (X,Y)   }
         Used[Y] := True; Tree[K].X := X; Tree[K].Y := Y
       end
  End;

PROCEDURE PRINT;
Var I : OGR;
  Begin
     WriteLn(',    : ');
     For I := 1 to N-1 do
       With Tree[I] do
         Write('(',X,',',Y,')=',M[X,Y],', ');
     WriteLn
  End;

BEGIN
  INIT;
  Prim;
  PRINT
END.