{ 
               ROM2DEC.PAS                                     
                     ,                                  
               BP 7.0                                          
  
            ,         
                             .               
  
               101                   
   }

{$X+}
PROGRAM ROM2DEC;
CONST MAX = 3999;
      Rom1_9 : Array[0..9] of String[4] =
      ('', 'A', 'AA', 'AAA', 'AB', 'B', 'BA', 'BAA', 'BAAA', 'AC');
TYPE OGR = 0..MAX;

FUNCTION Decimal_to_Roman(a : OGR) : String;

  Function GetDigit(a,Stepen : Byte) : String;
  Var Rezult    : String[4];
      RomDigits : String[3];
      Romans    : Array[#64..'C'] of Char absolute RomDigits;
      I         : Byte;
    Begin
       Rezult := '';
       Case Stepen of
         1 : RomDigits := 'IVX';
         2 : RomDigits := 'XLC';
         3 : RomDigits := 'CDM';
         4 : RomDigits := 'M  ';
       End;
       For I := 1 to Length(Rom1_9[a]) do
         Rezult := Rezult + Romans[Rom1_9[a,I]];
       GetDigit := Rezult
    End;

Var I, St  : Byte;
    Pom    : 0..9;
    Rezult : String;
  Begin
    Rezult := ''; St := 0;
    While a <> 0 do
      begin
        Pom := a mod 10; a := a div 10; Inc(St);
        Rezult := GetDigit(Pom,St) + Rezult
      end;
    Decimal_to_Roman := Rezult
  End;

FUNCTION Roman_to_Decimal(S : String; Var Error : Boolean) : OGR;
Var I          : Byte;
    Value, Old : 1..1000;
    Rezult     : Integer;
  Begin
    Old := 1000; Rezult := 0; Error := False;
    For I := 1 to Length(S) do
      begin
        Case S[I] of
          'I' : Value :=    1;
          'V' : Value :=    5;
          'X' : Value :=   10;
          'L' : Value :=   50;
          'C' : Value :=  100;
          'D' : Value :=  500;
          'M' : Value := 1000
          else begin Error := True; Break end
        End;
        If Value > Old then Dec(Rezult,2*Old);
        Inc(Rezult,Value); Old := Value
      end;
    Error := S <> Decimal_to_Roman(Rezult);
    Roman_to_Decimal := Rezult
  End;

VAR Digital : OGR;
    S       : String;
    Error   : Boolean;
BEGIN
  Write(',       : '); ReadLn(S);
  Digital := Roman_to_Decimal(S,Error);
  If Error then WriteLn('  !')
  else WriteLn('      ', Digital)
END.
