{ 
               POLYGON.PAS                                     
                     ,                                  
               BP 7.0                                          
  
                       
                          :        
                          , ,         
                           ,      
                             .              
  
               101                   
   }

PROGRAM POLYGON;
CONST MAX = 50;
      Eps = 0.01;
TYPE  DataType = Integer;
      OGR = 0..MAX;
      Coord = Record X,Y : DataType End;
      TPolygon = Array[OGR] of Coord;
VAR M : TPolygon;
    N : OGR;

CONST P : Coord = (X:10; Y:10); {   P }

PROCEDURE INIT(Var M : TPolygon; Var N : OGR);
{     }
Var F : TEXT;
    I : OGR;
  Begin
     Assign(F,'POLYGON.TXT'); Reset(F);
     ReadLn(F,N);
     For I := 1 to N do
       With M[I] do ReadLn(F,X,Y);
     Close(F)
  End;

FUNCTION Rast(X1,Y1,X2,Y2 : DataType) : Real;
{       .
      . }
  Begin
    Rast := Sqrt( Sqr(X2-X1) + Sqr(Y2-Y1) )
  End;

FUNCTION Perimeter(Var M : TPolygon; N : OGR) : Real;
{     }
Var I : OGR;
    Rezult : Real;
  Begin
     Rezult := 0;
     For I := 1 to N do
       Rezult := Rezult + Rast(M[I].X,M[I].Y,M[I+1].X,M[I+1].Y);
     Perimeter := Rezult
  End;

FUNCTION Lice(Var M : TPolygon; N : OGR) : Real;
{    ,        }
Var I : OGR;
    Rezult : Real;
  Begin
     Rezult := 0;
     For I := 1 to N do
       Rezult := Rezult + (M[I+1].X - M[I].X)*(M[I+1].Y + M[I].Y);
     Lice := Abs(Rezult/2)
  End;

FUNCTION ZnakTochka(X1,Y1,X2,Y2,X,Y : DataType) : DataType;
{         }
{ (X1,Y1)  (X2,Y2)     ,  (X,Y) -   }
  Begin
     ZnakTochka := (Y1-Y2)*X + (X2-X1)*Y + (X1*Y2-Y1*X2)
  End;

FUNCTION Zero(A : Real) : Boolean;
{    0,   ,      }
  Begin
     Zero := Abs(A) < Eps
  End;

FUNCTION Presicha(X1,Y1,X2,Y2,X3,Y3,X4,Y4 : DataType) : Boolean;
{    (X1,Y1)-(X2,Y2)  (X3,Y3)-(X4,Y4)   }
Var R1,R2,R3,R4 : DataType;
  Begin
    R1 := ZnakTochka(X1,Y1,X2,Y2,X3,Y3); R2 := ZnakTochka(X1,Y1,X2,Y2,X4,Y4);
    R3 := ZnakTochka(X3,Y3,X4,Y4,X1,Y1); R4 := ZnakTochka(X3,Y3,X4,Y4,X2,Y2);
    If Zero(R1) or Zero(R2) or Zero(R3) or Zero(R4) then
    {         ,  
       -           }
      Presicha :=
              Zero(Rast(X1,Y1,X3,Y3)+Rast(X3,Y3,X2,Y2)-Rast(X1,Y1,X2,Y2)) or
              Zero(Rast(X1,Y1,X4,Y4)+Rast(X4,Y4,X2,Y2)-Rast(X1,Y1,X2,Y2)) or
              Zero(Rast(X3,Y3,X1,Y1)+Rast(X1,Y1,X4,Y4)-Rast(X3,Y3,X4,Y4)) or
              Zero(Rast(X3,Y3,X2,Y2)+Rast(X2,Y2,X4,Y4)-Rast(X3,Y3,X4,Y4))
    {    -        
              }
    else Presicha := (((R1>0) and (R2<0)) or ((R1<0) and (R2>0))) and
                     (((R3>0) and (R4<0)) or ((R3<0) and (R4>0)))
  End;

FUNCTION SamoPres(Var M : TPolygon; N : OGR) : Boolean;
{      }
Var I,J : OGR;
  Begin
     M[N+1] := M[1]; {      }
     {          
         ,     }
     For I := 1 to N-1 do
       For J := I+1 to N do
         If ((J<I-1) or (J>I+1)) and ((I+N)<>(J+1)) and ((I+1)<>(J+N)) then
           If Presicha(M[I].X,M[I].Y,M[I+1].X,M[I+1].Y,
                       M[J].X,M[J].Y,M[J+1].X,M[J+1].Y) then
             begin SamoPres := True; Exit end;
     SamoPres := False
  End;

FUNCTION Izpuknal(Var M : TPolygon; N : OGR) : Boolean;
{      }
Var I,J,BrLeft,BrRight : OGR;
  Begin
     M[N+1] := M[1]; {      }
     {        
       ,    ,       }
     For I := 1 to N do
       begin
         BrLeft := 0; BrRight := 0;
         For J := 1 to N do
           If (I<>J) and ((I+1)<>J) and ((I+1)<>(J+N)) then
             begin
               If ZnakTochka(M[I].X,M[I].Y,M[I+1].X,M[I+1].Y,
                  M[J].X,M[J].Y) > 0 then Inc(BrLeft) else Inc(BrRight);
               If (BrLeft > 0) and (BrRight > 0) then
                 begin Izpuknal := False; Exit end
             end
       end;
     Izpuknal := True
  End;

FUNCTION Pravilen(Var M : TPolygon; N : OGR) : Boolean;
{     .    
   ,          . }
Var I,J : OGR;
    a,c,a0,c0 : Real;
  Begin
    M[N+1] := M[1]; M[N+2] := M[2]; {    }
    a0 := Rast(M[1].X,M[1].Y,M[2].X,M[2].Y);
    c0 := Rast(M[1].X,M[1].Y,M[3].X,M[3].Y);
    For I := 2 to N do
      begin
        a := Rast(M[I].X,M[I].Y,M[I+1].X,M[I+1].Y);
        c := Rast(M[I].X,M[I].Y,M[I+2].X,M[I+2].Y);
        If (a <> a0) or (c <> c0) then begin Pravilen := False; Exit end
      end;
    Pravilen := True
  End;

FUNCTION Vutre(Var M : TPolygon; N : OGR; P : Coord) : Boolean;
  {    P     }
Var PomM  : TPolygon;
    I,J   : OGR;
    LiceM : Real;
  Begin
     LiceM := Lice(M,N);
     For I := 1 to N do
       begin
         {    - PomM,    P   }
         For J := 1 to I do PomM[J] := M[J];
         PomM[I+1] := P;
         For J := I+1 to N+1 do PomM[J+1] := M[J];
         If not SamoPres(PomM,N+1) then {     PomM }
           {    -   .
                 -    . }
           begin Vutre := LiceM > Lice(PomM,N+1); Exit end
       end;
     Vutre := True
  End;

BEGIN
  INIT(M,N);
  WriteLn;
  WriteLn('   : ',Perimeter(M,N):0:2);
  WriteLn('   : ',Lice(M,N):0:2);
  If SamoPres(M,N) then WriteLn('  !')
              else WriteLn('   !');
  If Izpuknal(M,N) then WriteLn('  !')
              else WriteLn('  !');
  If Pravilen(M,N) then WriteLn('  !')
              else WriteLn('   !');
  If Vutre(M,N,P) then
     WriteLn(' (',P.X,',',P.Y,')    !')
  else WriteLn(' (',P.X,',',P.Y,
               ')        !');
END.